/*
Copyright (C) 1996-2001 Id Software, Inc.
Copyright (C) 2002-2009 John Fitzgibbons and others
Copyright (C) 2010-2014 QuakeSpasm developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __CONSOLE_H
#define __CONSOLE_H

void Con_DrawCharacter(int cx, int line, int num);

namespace console {
    extern int total_lines;
    extern int back_scroll;
    extern bool forced_up;
    extern bool initialized;
    extern std::string last_center_string;

    void init();

    void line_feed();

    void info(const char *fmt, ...);

    void warn(const char *fmt, ...);

    void dev_warn(const char *fmt, ...);

    void debug(const char *fmt, ...);

    void trace(const char *fmt, ...);

    void safe_print(const char *fmt, ...);

    void toggle_console();

    void check_resize();

}

void Con_DrawConsole(int lines, bool drawinput);

void Con_DrawNotify(void);

void Con_ClearNotify(void);

void Con_NotifyBox(const char *text); // during startup for sound / cd warnings

const char *Con_Quakebar(int len);

void Con_TabComplete(void);

void Con_LogCenterPrint(const char *str);

//
// debuglog
//
void LOG_Init(quakeparms_t *parms);

void LOG_Close(void);

void Con_DebugLog(const char *msg);

#endif	/* __CONSOLE_H */
